// DlgAutoExec.cpp : implementation file
//

#include "stdafx.h"
#include "Wc8kUI.h"
#include "DlgAutoExec.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgAutoExec dialog
extern long          g_nPluginID;
extern SENDREQUEST   g_SendRequest;
extern TRANSMITFILE  g_TransmitFile;

CDlgAutoExec::CDlgAutoExec(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAutoExec::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAutoExec)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_PluginName = "Autoexec Programs";
}


void CDlgAutoExec::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAutoExec)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgAutoExec, CDialog)
	//{{AFX_MSG_MAP(CDlgAutoExec)
	ON_BN_CLICKED(IDC_BTN_REFRESH, OnBtnRefresh)
	ON_BN_CLICKED(IDC_BTN_SAVESETTING, OnBtnSavesetting)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_GETTEXT,OnGetWindowText)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgAutoExec message handlers

void CDlgAutoExec::OnOK() 
{
	// TODO: Add extra validation here
	
	//CDialog::OnOK();
}

void CDlgAutoExec::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	//CDialog::OnCancel();
}

void CDlgAutoExec::OnBtnRefresh() 
{
	// TODO: Add your control notification handler code here
	
	char* pCmd = "get autoexec.cfg";

	g_SendRequest(g_nPluginID,
		          (long)this,
				  "Plugin4W8k.dll",
                  pCmd,
				  strlen(pCmd),
				  CDlgAutoExec::OnResponse);
}

void CDlgAutoExec::OnBtnSavesetting() 
{
	char szBuf[4096]={0};
    char szMsg[512];

	strcpy(szBuf,"set autoexec.cfg\r\n");

	UINT ID[] = {IDC_EDIT_PROG_1,
		         IDC_EDIT_PROG_2,
				 IDC_EDIT_PROG_3,
				 IDC_EDIT_PROG_4,
				 IDC_EDIT_PROG_5,
				 IDC_EDIT_PROG_6,
				 IDC_EDIT_PROG_7,
				 IDC_EDIT_PROG_8,
				 IDC_EDIT_PROG_9,
				 IDC_EDIT_PROG_10};
    for(int i=0;i<10;i++)
	{
        CString sFile;
		GetDlgItemText(ID[i],sFile);
		if(sFile.IsEmpty())
			sprintf(szMsg,"Launch%d=\r\n",80 + i);
		else
			sprintf(szMsg,"Launch%d=%s\r\n",80 + i,(LPCTSTR)sFile);
		strcat(szBuf,szMsg);
	}

	g_SendRequest(g_nPluginID,
		          (long)this,
				  "Plugin4W8k.dll",
				  szBuf,
				  strlen(szBuf),
				  CDlgAutoExec::OnResponse);
}

int CDlgAutoExec::GetIDByName(const char *szName)
{
    if(strcmp(szName,"Launch80") == 0)
		return IDC_EDIT_PROG_1;
	else if(strcmp(szName,"Launch81") == 0)
		return IDC_EDIT_PROG_2;
	else if(strcmp(szName,"Launch82") == 0)
		return IDC_EDIT_PROG_3;
	else if(strcmp(szName,"Launch83") == 0)
		return IDC_EDIT_PROG_4;
	else if(strcmp(szName,"Launch84") == 0)
		return IDC_EDIT_PROG_5;
	else if(strcmp(szName,"Launch85") == 0)
		return IDC_EDIT_PROG_6;
	else if(strcmp(szName,"Launch86") == 0)
		return IDC_EDIT_PROG_7;
	else if(strcmp(szName,"Launch87") == 0)
		return IDC_EDIT_PROG_8;
	else if(strcmp(szName,"Launch88") == 0)
		return IDC_EDIT_PROG_9;
	else if(strcmp(szName,"Launch89") == 0)
		return IDC_EDIT_PROG_10;

	return -1;
}

void CDlgAutoExec::ProcessMsg(const char *Buf, int Len)
{
    if(Buf == NULL || Len == 0)
		return;

	char* pBuf = new char[Len + 1];
	memcpy(pBuf,Buf,Len);
	pBuf[Len] = 0;

	char* pToken = strtok(pBuf,"\r\n");
	while(pToken != NULL)
	{
        char* pEqual = strchr(pToken,'=');
		if(pEqual != NULL)
		{
            *pEqual = 0;
			char* pValue = pEqual + 1;
			int nID = GetIDByName(pToken);
			if(nID != -1)
			    SetDlgItemText(nID,pValue);
			
		}

		pToken = strtok(NULL,"\r\n");
	}

	delete [] pBuf;   
}

void CDlgAutoExec::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDialog::PostNcDestroy();

	delete this;
}

void CDlgAutoExec::OnResponse(long nResult,
							  long nUserData,
							  const char *Buf,
							  long nBufLen)
{
    CDlgAutoExec* pDlg = (CDlgAutoExec*)nUserData;
	if(nResult > 0)
		pDlg->ProcessMsg(Buf,nBufLen);
	else
	{
        // TODO ...... 
	}
}

LRESULT CDlgAutoExec::OnGetWindowText(WPARAM wParam, LPARAM lParam)
{
    int nBytesToCopy = (int)wParam;
	char* pBuf = (char*)lParam;

	strncpy(pBuf,(LPCTSTR)m_PluginName,nBytesToCopy);

	return strlen(pBuf);
}
