// DlgSysInfo.cpp : implementation file
//

#include "stdafx.h"
#include "Wc8kUI.h"
#include "DlgSysInfo.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgSysInfo dialog
extern long          g_nPluginID;
extern SENDREQUEST   g_SendRequest;
extern TRANSMITFILE  g_TransmitFile;

CDlgSysInfo::CDlgSysInfo(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgSysInfo::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgSysInfo)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_PluginName = "System Information";
}


void CDlgSysInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgSysInfo)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgSysInfo, CDialog)
	//{{AFX_MSG_MAP(CDlgSysInfo)
	ON_BN_CLICKED(IDC_BTN_REFRESH, OnBtnRefresh)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_GETTEXT,OnGetWindowText)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgSysInfo message handlers

void CDlgSysInfo::OnOK() 
{
	// TODO: Add extra validation here
	
	//CDialog::OnOK();
}

void CDlgSysInfo::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	//CDialog::OnCancel();
}

void CDlgSysInfo::OnBtnRefresh() 
{
    
	char* pCmd = "get sysinfo";
	g_SendRequest(g_nPluginID,
		          (long)this,
		          "Plugin4W8k.dll",
				  pCmd,
				  strlen(pCmd),
				  OnResponse);
}

int CDlgSysInfo::GetIDByName(const char *szName)
{
    if(strcmp(szName,"SLOT1") == 0)
		return IDC_STATIC_SLOT_1;
    else if(strcmp(szName,"SLOT2") == 0)
		return IDC_STATIC_SLOT_2;
    else if(strcmp(szName,"SLOT3") == 0)
		return IDC_STATIC_SLOT_3;
	else if(strcmp(szName,"SLOT4") == 0)
		return IDC_STATIC_SLOT_4;
	else if(strcmp(szName,"SLOT5") == 0)
		return IDC_STATIC_SLOT_5;
	else if(strcmp(szName,"SLOT6") == 0)
		return IDC_STATIC_SLOT_6;
	else if(strcmp(szName,"SLOT7") == 0)
		return IDC_STATIC_SLOT_7;
	else if(strcmp(szName,"SERIALNUM") == 0)
		return IDC_STATIC_SERIAL_NUM;
	else if(strcmp(szName,"MACADDR") == 0)
		return IDC_STATIC_MAC;
	else if(strcmp(szName,"EEPROM_SIZE") == 0)
		return IDC_STATIC_EEPROM_SIZE;
	else if(strcmp(szName,"FLASH_SIZE") == 0)
		return IDC_STATIC_FLASH_SIZE;
	else if(strcmp(szName,"OS_SIZE") == 0)
		return IDC_STATIC_OS_SIZE;
	else if(strcmp(szName,"OS_VERSION") == 0)
		return IDC_STATIC_OS_VERSION;
	else if(strcmp(szName,"SDK_VERSION") == 0)
		return IDC_STATIC_SDK_VER;

	return -1;
}

void CDlgSysInfo::ProcessMsg(const char *Buf, int Len)
{
    if(Buf == NULL || Len == 0)
		return;

	char* pBuf = new char[Len + 1];
	memcpy(pBuf,Buf,Len);
	pBuf[Len] = 0;

	char* pToken = strtok(pBuf,"\r\n");
	while(pToken != NULL)
	{
        char* pEqual = strchr(pToken,'=');
		if(pEqual != NULL)
		{
            *pEqual = 0;
			char* pValue = pEqual + 1;
			int nID = GetIDByName(pToken);
			if(nID != -1)
			    SetDlgItemText(nID,pValue);
			
		}

		pToken = strtok(NULL,"\r\n");
	}

	delete [] pBuf;
}

void CDlgSysInfo::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CDialog::PostNcDestroy();

	delete this;
}

void CDlgSysInfo::OnResponse(long nResult,
							 long nUserData,
							 const char *Buf,
							 long nBufLen)
{
    CDlgSysInfo* pDlg = (CDlgSysInfo*)nUserData;
	if(nResult > 0)
		pDlg->ProcessMsg(Buf,nBufLen);
	else
	{
        // TODO ...... 
	}
}

LRESULT CDlgSysInfo::OnGetWindowText(WPARAM wParam, LPARAM lParam)
{
    int nBytesToCopy = (int)wParam;
	char* pBuf = (char*)lParam;

	strncpy(pBuf,(LPCTSTR)m_PluginName,nBytesToCopy);

	return strlen(pBuf);
}
